#pragma comment(lib, "msi.lib")

#include <windows.h>
#include <msi.h>
#include <msiquery.h>

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR szPackagePath, int
nShowCmd)
{
 if (lstrlen(szPackagePath) == 0)
 {
  MessageBox(
   NULL,
   TEXT("Drop an MSI database on me, and I'll fix the Shortcut table."),
   TEXT("Usage"),
   MB_OK | MB_ICONINFORMATION);

  exit(0);
 }

 if (MsiVerifyPackage(szPackagePath) != ERROR_SUCCESS)
 {
  MessageBox(
   NULL,
   TEXT("You need to specify a valid MSI package."),
   TEXT("Error"),
   MB_OK | MB_ICONERROR);

  exit(1);
 }

 MSIHANDLE hDB = NULL;
 MsiOpenDatabase(szPackagePath, MSIDBOPEN_DIRECT, &hDB);

 MSIHANDLE hView = NULL;
 MsiDatabaseOpenView(hDB, TEXT("SELECT ShowCmd FROM Shortcut"), &hView);

 MsiViewExecute(hView, 0);

 MSIHANDLE hRecord = NULL;
 while (MsiViewFetch(hView, &hRecord) == ERROR_SUCCESS)
 {
  INT showcmd = MsiRecordGetInteger(hRecord, 1);

  if (showcmd == 0)
  {
   MsiRecordSetInteger(hRecord, 1, 1);
   MsiViewModify(hView, MSIMODIFY_UPDATE, hRecord);
  }
 }

 MsiViewClose(hView);
 MsiDatabaseCommit(hDB);

 MsiCloseHandle(hRecord);
 MsiCloseHandle(hView);
 MsiCloseHandle(hDB);

 return 0;
}

